# TODO: gdrdrv.ko kernel module
#
# Conditional build:
%bcond_with	kernel		# kernel module
%bcond_without	userspace	# userspace library
#
Summary:	GDRCopy - low-latency GPU memory copy library
Summary(pl.UTF-8):	GDRCopy - biblioteka kopiowania pamięci GPU o małym opóźnieniu
Name:		gdrcopy
Version:	2.5
Release:	1
License:	MIT
Group:		Libraries
#Source0Download: https://github.com/NVIDIA/gdrcopy/releases
Source0:	https://github.com/NVIDIA/gdrcopy/archive/v%{version}/%{name}-%{version}.tar.gz
# Source0-md5:	1a9e534d6a1eaa2cc1333e7cddac3b12
URL:		https://github.com/NVIDIA/gdrcopy
%ifarch %{ix86}
Requires:	cpuinfo(sse2)
%endif
ExclusiveArch:	%{ix86} %{x8664} x32 ppc ppc64 aarch64
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
A low-latency GPU memory copy library based on NVIDIA GPUDirect RDMA
technology.

%description -l pl.UTF-8
Biblioteka kopiowania pamięci GPU o małym opóźnieniu, oparta na
technologii NVIDIA GPUDirect RDMA.

%package devel
Summary:	Header files for GDRCopy library
Summary(pl.UTF-8):	Pliki nagłówkowe biblioteki GDRCopy
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}

%description devel
Header files for GDRCopy library.

%description devel -l pl.UTF-8
Pliki nagłówkowe biblioteki GDRCopy.

%prep
%setup -q

%build
%if %{with userspace}
# there is runtime SSE/SSE4.1/AVX detection, but common code uses inline instructions:
# sfence (from SSE set) and mfence (from SSE2 set)
%ifarch %{ix86}
ARCH_CFLAGS="-msse2"
%else
ARCH_CFLAGS=
%endif

%{__make} lib \
	CC="%{__cc}" \
	COMMONCFLAGS="%{rpmcflags} %{rpmcppflags} ${ARCH_CFLAGS}"
%endif

%if %{with kernel}
%{__make} -C src/gdrdrv
%endif

%install
rm -rf $RPM_BUILD_ROOT

%if %{with userspace}
%{__make} lib_install \
	DESTDIR=$RPM_BUILD_ROOT \
	prefix=%{_prefix} \
	libdir=%{_libdir}
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun	-p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc CHANGELOG.md LICENSE README.md
%attr(755,root,root) %{_libdir}/libgdrapi.so.*.*
%ghost %{_libdir}/libgdrapi.so.2

%files devel
%defattr(644,root,root,755)
%{_libdir}/libgdrapi.so
%{_includedir}/gdrapi.h
%{_includedir}/gdrconfig.h
%changelog
* Fri Jun 13 2025 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/gdrcopy.git;a=log;h=master

* Fri Jun 13 2025 Jakub Bogusz <qboosh@pld-linux.org> f03a8ed
- new

